Index: trunk/source/processes/electromagnetic/adjoint/src/G4VEmAdjointModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/adjoint/src/G4VEmAdjointModel.cc	(revision 966)
+++ trunk/source/processes/electromagnetic/adjoint/src/G4VEmAdjointModel.cc	(revision 1196)
@@ -853,14 +655,16 @@
     	currentMaterialIndex = currentMaterial->GetIndex();
    	size_t idx=56;
-    
+    	currentTcutForDirectPrim =0.00000000001;
    	if (theAdjEquivOfDirectPrimPartDef) {
     		if (theAdjEquivOfDirectPrimPartDef->GetParticleName() == "adj_gamma") idx = 0;
    		else if (theAdjEquivOfDirectPrimPartDef->GetParticleName() == "adj_e-") idx = 1;
     		else if (theAdjEquivOfDirectPrimPartDef->GetParticleName() == "adj_e+") idx = 2;
-    		const std::vector<G4double>* aVec = G4ProductionCutsTable::GetProductionCutsTable()->GetEnergyCutsVector(idx);
-    		currentTcutForDirectPrim=(*aVec)[currentCoupleIndex];
+    		if (idx <56){
+			const std::vector<G4double>* aVec = G4ProductionCutsTable::GetProductionCutsTable()->GetEnergyCutsVector(idx);
+    			currentTcutForDirectPrim=(*aVec)[currentCoupleIndex];
+		}	
     	}	
     
-    
+    	currentTcutForDirectSecond =0.00000000001;
     	if (theAdjEquivOfDirectPrimPartDef == theAdjEquivOfDirectSecondPartDef) {
     		currentTcutForDirectSecond = currentTcutForDirectPrim;
@@ -873,6 +677,35 @@
     			const std::vector<G4double>* aVec = G4ProductionCutsTable::GetProductionCutsTable()->GetEnergyCutsVector(idx);
     			currentTcutForDirectSecond=(*aVec)[currentCoupleIndex];
+			if (idx <56){
+				const std::vector<G4double>* aVec = G4ProductionCutsTable::GetProductionCutsTable()->GetEnergyCutsVector(idx);
+    				currentTcutForDirectPrim=(*aVec)[currentCoupleIndex];
+			}
+			
+			
 		}
     	}
   }
 }
+////////////////////////////////////////////////////////////////////////////////////////////
+//
+void G4VEmAdjointModel::SetHighEnergyLimit(G4double aVal)
+{ HighEnergyLimit=aVal;
+  if (theDirectEMModel) theDirectEMModel->SetHighEnergyLimit( aVal);
+}
+////////////////////////////////////////////////////////////////////////////////////////////
+//
+void G4VEmAdjointModel::SetLowEnergyLimit(G4double aVal)
+{
+  LowEnergyLimit=aVal;
+  if (theDirectEMModel) theDirectEMModel->SetLowEnergyLimit( aVal);
+}
+////////////////////////////////////////////////////////////////////////////////////////////
+//
+void G4VEmAdjointModel::SetAdjointEquivalentOfDirectPrimaryParticleDefinition(G4ParticleDefinition* aPart)
+{
+  theAdjEquivOfDirectPrimPartDef=aPart;
+  if (theAdjEquivOfDirectPrimPartDef->GetParticleName() =="adj_e-")
+					theDirectPrimaryPartDef=G4Electron::Electron();
+  if (theAdjEquivOfDirectPrimPartDef->GetParticleName() =="adj_gamma")
+					theDirectPrimaryPartDef=G4Gamma::Gamma();
+}
Index: trunk/source/processes/electromagnetic/adjoint/src/G4eInverseBremsstrahlung.cc
===================================================================
--- trunk/source/processes/electromagnetic/adjoint/src/G4eInverseBremsstrahlung.cc	(revision 966)
+++ trunk/source/processes/electromagnetic/adjoint/src/G4eInverseBremsstrahlung.cc	(revision 1196)
@@ -24,4 +24,7 @@
 // ********************************************************************
 //
+// $Id: G4eInverseBremsstrahlung.cc,v 1.4 2009/11/20 10:31:20 ldesorgh Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
+//
 #include "G4eInverseBremsstrahlung.hh"
 #include "G4VEmAdjointModel.hh"
@@ -31,7 +34,9 @@
 //
 G4eInverseBremsstrahlung::G4eInverseBremsstrahlung(G4bool whichScatCase,G4String process_name,G4AdjointBremsstrahlungModel* aBremAdjointModel):
-				G4VAdjointInverseScattering(process_name,whichScatCase)
+				G4VAdjointReverseReaction(process_name,whichScatCase)
 {theAdjointEMModel = aBremAdjointModel;
- theAdjointEMModel->SetSecondPartOfSameType(false); 
+ theAdjointEMModel->SetSecondPartOfSameType(false);
+ if (IsScatProjToProjCase) SetIntegralMode(true);
+ else   SetIntegralMode(false);
 }
 /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
Index: trunk/source/processes/electromagnetic/adjoint/src/G4eInverseCompton.cc
===================================================================
--- trunk/source/processes/electromagnetic/adjoint/src/G4eInverseCompton.cc	(revision 966)
+++ trunk/source/processes/electromagnetic/adjoint/src/G4eInverseCompton.cc	(revision 1196)
@@ -24,4 +24,7 @@
 // ********************************************************************
 //
+// $Id: G4eInverseCompton.cc,v 1.4 2009/11/20 10:31:20 ldesorgh Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
+//
 ///////////////////////////////////////////////////////
 // File name:     G4eInverseCompton
@@ -39,7 +42,10 @@
 //
 G4eInverseCompton::G4eInverseCompton(G4bool whichScatCase,G4String process_name,G4AdjointComptonModel* aComptonAdjointModel):
-				G4VAdjointInverseScattering(process_name,whichScatCase)
+				G4VAdjointReverseReaction(process_name,whichScatCase)
 {theAdjointEMModel = aComptonAdjointModel;
- theAdjointEMModel->SetSecondPartOfSameType(false); 
+ theAdjointEMModel->SetSecondPartOfSameType(false);
+ SetIntegralMode(false);
+ /*if (IsScatProjToProjCase) SetIntegralMode(false);
+ else   SetIntegralMode(true); */
 }
 /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
Index: trunk/source/processes/electromagnetic/adjoint/src/G4eInverseIonisation.cc
===================================================================
--- trunk/source/processes/electromagnetic/adjoint/src/G4eInverseIonisation.cc	(revision 966)
+++ trunk/source/processes/electromagnetic/adjoint/src/G4eInverseIonisation.cc	(revision 1196)
@@ -24,4 +24,7 @@
 // ********************************************************************
 //
+// $Id: G4eInverseIonisation.cc,v 1.4 2009/11/20 10:31:20 ldesorgh Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
+//
 ///////////////////////////////////////////////////////
 // File name:     G4eInverseIonisation
@@ -38,7 +41,9 @@
 //
 G4eInverseIonisation::G4eInverseIonisation(G4bool whichScatCase,G4String process_name,G4VEmAdjointModel* aEmAdjointModel):
-				G4VAdjointInverseScattering(process_name,whichScatCase)
+				G4VAdjointReverseReaction(process_name,whichScatCase)
 {theAdjointEMModel = aEmAdjointModel;
  theAdjointEMModel->SetSecondPartOfSameType(true); 
+ SetIntegralMode(true);
+
 }
 /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
